import numpy as np
import string

letters = list(string.ascii_lowercase)
letters.remove("h")
letters.remove("x")
letters.remove("f")

def read_image(fname):
    with open(fname) as f:
        data = [map(int, line.strip().split()) for line in f]
        return np.array(data)

base = {l:read_image("alphabet/" + l + ".in") for l in letters}


CAPTCHA_SIZE=6
WIDTH=100
HEIGHT=70

TESTCASES = 800

for i in range(1, 1+TESTCASES):
    data = read_image("easy/%03d.in" % i)
    assert SIZE*WIDTH == data.shape[1]
    result = ""
    for j in range(CAPTCHA_SIZE):
        block = np.copy(data[:,j*WIDTH:(j+1)*WIDTH])
        best = (1e10, "_") # Best letter is undefined so far
        for l in letters:
            assert block.shape == base[l].shape
            best2 = 1e10 # Best shift for letter l is undefined so far
            # try different shifts
            for dx in range(-10,11):
                for dy in range(-5, 6):
                    # subselect overlapping part of the images
                    a = block[max(dy,0):HEIGHT - max(-dy,0),max(dx,0):WIDTH - max(-dx,0)]
                    b = base[l][max(-dy,0):HEIGHT - max(dy,0),max(-dx,0):WIDTH - max(dx,0)]
                    # cost is simply the difference
                    cost = np.sum(np.abs(a-b))
                    best2 = min(best2, cost)
            best = min(best, (best2, l))
        result += best[1]
    print result
